dnl
dnl Find most recent tclsh / wish
dnl
AC_DEFUN(fp_FIND_TCLSHORWISH, [[
fpft_what="$1"
fpft_pfad=`echo $PATH | sed 's/:/ /g'`
fpft_pfad="$fpft_pfad /bin /usr/bin /usr/local/bin /local/bin /opt/bin"
fpft_pfad="$fpft_pfad /usr/share/bin $HOME/bin $prefix/bin $2 $2/bin"

for fpft_dir in $fpft_pfad ; do
	if test "x$fpft_dir" = "x" ; then
		continue
	elif test ! -d $fpft_dir ; then
		continue
	fi
	for fpft_file in $fpft_dir/$fpft_what* ; do
		fpft_base=`echo $fpft_file | sed 's=^.*/=='`
		if test "x$fpft_base" = "x$fpft_what*" ; then
			break
		fi

		fpft_ver=[`echo $fpft_base | sed 's=^[^0-9]*==' | sed 's=[^0-9.].*$=='`]
		fpft_major=[`echo $fpft_ver | sed 's=\.[0-9].*=='`]
		fpft_minor=[`echo $fpft_ver | sed 's=^[^.]*.=='`]

		if test "x$fpft_res" = "x" || test "x$fpft_omajor" = "x" ; then
			fpft_res=$fpft_file
			fpft_omajor=$fpft_major
			fpft_ominor=$fpft_minor
			continue
		fi

		if test "x$fpft_ver" = "x" ; then
			fpft_major=0
			fpft_minor=0
		elif test "x$fpft_major" = "x" ; then
			fpft_major=0
			fpft_minor=0
		elif test "x$fpft_minor" = "x" ; then
#
# Some installations drop the dot between major and minor version number,
# so we're getting majors like 42 or 80, but no minor. Expect there's no
# *real* tcl 20 in the near future ...
#
			if test $fpft_major -gt 20 ; then
				fpft_minor=[`echo $fpft_major | sed 's/^.*\(.\)/\1/'`]
				fpft_major=[`echo $fpft_major | sed 's/.$//'`]
			else
				fpft_minor=0
			fi
		fi

#
# Test if the wish version number looks suspicious. If we have a better
# choice, ignore this one. For example, on one system there was a `wish73',
# which was really Tcl 7.3 / Tk 3.6. Make sure we'd prefer something known
# over an obscure number.
#

		if test $fpft_major -lt 8 && test $fpft_major -ne 4 ; then
			if test $fpft_omajor -eq 4 && test $fpft_ominor -lt 3 ; then
				continue
			fi
		fi
		if test $fpft_omajor -lt 8 && test $fpft_omajor -ne 4 ; then
			if test $fpft_major -eq 4 && test $fpft_minor -lt 3 ; then
				fpft_res=$fpft_file
				fpft_omajor=$fpft_major
				fpft_ominor=$fpft_minor
				continue
			fi
		fi
#
# Otherwise, act by version number
#
		if test $fpft_major -gt $fpft_omajor ; then
			fpft_res=$fpft_file
			fpft_omajor=$fpft_major
			fpft_ominor=$fpft_minor
		elif test $fpft_major -eq $fpft_omajor && test $fpft_minor -gt $fpft_ominor ; then
			fpft_res=$fpft_file
			fpft_omajor=$fpft_major
			fpft_ominor=$fpft_minor
		fi
	done
done
eval fp_cv_prog_$fpft_what=$fpft_res
]])

AC_DEFUN(fp_FIND_TCLSH, [
AC_ARG_WITH(tclsh, [  --with-tclsh=path       select a specific tclsh],TCLSH=$withval)
AC_MSG_CHECKING(for tclsh)
if test "x$TCLSH" = "x" || test ! -f $TCLSH ; then
	AC_CACHE_VAL(fp_cv_prog_tclsh,fp_FIND_TCLSHORWISH(tclsh,$TCLSH))
	if test "x$fp_cv_prog_tclsh" = "x" ; then
		AC_MSG_RESULT(not found)
	else
		AC_MSG_RESULT($fp_cv_prog_tclsh)
	fi
	TCLSH=$fp_cv_prog_tclsh
else
	AC_MSG_RESULT($TCLSH)
fi
])

AC_DEFUN(fp_FIND_WISH, [
AC_ARG_WITH(wish, [  --with-wish=path        select a specific wish],WISH=$withval)
AC_MSG_CHECKING(for wish)
if test "x$WISH" = "x" || test ! -f $WISH ; then
	AC_CACHE_VAL(fp_cv_prog_wish,fp_FIND_TCLSHORWISH(wish,$WISH))
	if test "x$fp_cv_prog_wish" = "x" ; then
		AC_MSG_RESULT(not found)
	else
		AC_MSG_RESULT($fp_cv_prog_wish)
	fi
	WISH=$fp_cv_prog_wish
else
	AC_MSG_RESULT($WISH)
fi
])

