#! @WISH@

#
# ----------------------------------------------------------------------
# PPL-Check
#
# Dieses Programm ist urheberrechtlich geschtzt. nderungen und Weiter-
# gabe sind nur mit schriftlicher Genehmigung des Autors zulssig.
#
#                                                 Frank  Pilhofer
#                                                    fp@fpx.de
#
# ----------------------------------------------------------------------
#

set pplrev {$Id: ppl.tcl,v 1.14 2004/02/08 22:41:17 fp Exp $}

if {![info exists tk_version]} {
    puts "Bitte starten Sie $argv0 mit wish statt tclsh."
    exit 1
}

if {$tk_version < 4.2} {
    tk_dialog .dialog {Dinosaur Alert!} "Ihre Tcl/Tk Installation\
	    ist zu alt. Bitte installieren Sie Tcl 7.6 / Tk 4.2 oder\
	    neuer." warning 0 "Na klar"
    exit 1
}

#
# Versuche herauszufinden, in welchem Directory ich gestartet wurde
#

set magicfile ppl.txt

set dirs ". .."
lappend dirs [file dirname [info script]]
lappend dirs [file dirname $argv0]
lappend dirs [file dirname [file dirname [info script]]]
lappend dirs [pwd]
lappend dirs [file dirname [pwd]]

if {[info exists env(PPL)]} {
    lappend dirs $env(PPL)
}

foreach dir $dirs {
    if {[file exists [file join $dir $magicfile]]} {
	set base $dir
    }
    if {[file exists [file join $dir loadq.tcl]]} {
	set bin $dir
    }
    if {[file isdirectory [file join $dir kat]]} {
	set data [file join $dir kat]
    }
    if {[file isdirectory [file join $dir img]]} {
	set img [file join $dir img]
    }
}

if {![info exists base]} {
    tk_dialog .dialog {Oops} "Aus unerfindlichen Grnden kann ich das\
	    Quellverzeichnis nicht finden. Bitte wechseln Sie in der\
	    folgenden Dialogbox in das Quellverzeichnis und whlen\
	    Sie die Datei $magicfile" warning 0 OK
    if {[catch {set f [tk_getOpenFile]}]} {
	exit 1
    } elseif {[file exists [file join [file dirname $f] $magicfile]]} {
	set base [file dirname $f]
    } else {
	exit 1
    }
}

if {![info exists bin]} {
    if {[file exists [file join [file join $base bin] loadq.tcl]]} {
	set bin [file join $base bin]
    } else {
	set bin $base
    }
}

if {![info exists data]} {
    set data [file join $base kat]
}

if {![info exists img]} {
    set img [file join $base img]
}

if {![info exists HAVE_LOADQ]} {
    source [file join $bin loadq.tcl]
}

# ----------------------------------------------------------------------
# Schau nach, welche Kataloge wir so haben
# ----------------------------------------------------------------------

foreach kat [glob -nocomplain [file join $data *.kat]] {
    catch {
	source $kat
    }
}

if {[llength [array names kataloge]] == 0} {
    tk_dialog .dialog {Oops} "Es sind keine Fragenkataloge geladen.\
	    Seltsam. Bitte stellen Sie sicher, da sich die\
	    \"*.kat\"-Dateien im Verzeichnis $data befinden und\
	    lesbar sind." warning 0 OK
    exit 1
}

# ----------------------------------------------------------------------
# Lade eine ini-Datei wenn vorhanden
# ----------------------------------------------------------------------

catch {
    if {[info exists ffont]} {
	set oldffont $ffont
	unset ffont
    }
    if {[info exists afont]} {
	set oldafont $afont
	unset afont
    }

    if {[info exists env(WINDIR)]} {
	if [file exists [file join $env(WINDIR) ppl.ini]] {
	    catch {source [file join $env(WINDIR) ppl.ini]}
	}
    }

    if {[file exists [file join $base ppl.ini]]} {
	catch {source [file join $base ppl.ini]}
    }

    if {[info exists env(HOME)]} {
	if [file exists [file join $env(HOME) .pplrc]] {
	    catch {source [file join $env(HOME) .pplrc]}
	}
    }

    if {![catch {set tk_version}] && $tk_version >= 8.0} {
	if {[info exists ffont] && [llength $ffont] == 3} {
	    set ffont [font create -family [lindex $ffont 0] \
		    -size [lindex $ffont 1] \
		    -weight [lindex $ffont 2]]
	} elseif [info exists oldffont] {
	    set ffont $oldffont
	}
	if {[info exists afont] && [llength $afont] == 3} {
	    set afont [font create -family [lindex $afont 0] \
		    -size [lindex $afont 1] \
		    -weight [lindex $afont 2]]
	} elseif [info exists oldafont] {
	    set afont $oldafont
	}
    }
}

# ----------------------------------------------------------------------
# Font stuff
# ----------------------------------------------------------------------

if {[catch {set tk_version}] || $tk_version < 8.0} {
    set ffont "-Adobe-Helvetica-Bold-R-Normal--*-140-*-*-*-*-*-*"
    set afont "-Adobe-Helvetica-Bold-R-Normal--*-100-*-*-*-*-*-*"
} else {
    if {![info exists ffont]} {
	set ffont [font create -family Helvetica -size 12 -weight bold]
    }
    if {![info exists afont]} {
	set afont [font create -family Helvetica -size 10 -weight bold]
    }
}

if {![catch {set tk_version}] && $tk_version >= 8.0} {
#
# dummy values
#
    ifndef fwidth 66
    set flen   300
    set alen   300
} else {
    if {$tcl_platform(platform) == "windows"} {
	ifndef flen 4.5i
	ifndef alen 4i
	ifndef fwidth 62
    } else {
	ifndef flen 6i
	ifndef alen 5.5i
	ifndef fwidth 60
    }
}

ifndef fheight 6
ifndef aheight 4

#
# Die nativen Mens von Tk 8.0 in Unix sind buggy
#

if {[catch {set tk_version}] || $tk_version < 8.0 || \
	($tk_patchLevel == "8.0" && $tcl_platform(platform) == "unix")} {
    set oldMenus 1
} else {
    set oldMenus 0
}

#
# ----------------------------------------------------------------------
#

#
# Status:  0 gar nichts
#          1 Freistil Abfrage
#          2 Freistil Auswertung
#          3 Prfung Abfrage
#          4 Prfung Auswertung
#

ifndef AutoForward 1
ifndef status      0
ifndef katalog     ""
ifndef aw          0
ifndef KatList     ""
ifndef fsImmediate 0
ifndef cheat       0
ifndef ImgExtThres 80
ifndef PDefAnz     20
ifndef whatppl     "C"
ifndef whatkat     ""
ifndef scramblea   1
ifndef scrambleq   1
ifndef imgcache    0

#
# ----------------------------------------------------------------------
#

proc ConfigureFAFonts {main} {
    global tk_version

    if {[catch {set tk_version}] || $tk_version < 8.0} {
	return
    }

    set ffont  [lindex [$main.fa.frage configure -font] 4]
    set fwidth [lindex [$main.fa.frage configure -width] 4]
    set flen   [expr $fwidth * [font measure $ffont "0"]]
    set fwrap  [expr $flen - 3 * [font measure $ffont "0"]]
    set awrap  [expr $fwrap - 6 * [font measure [lindex [$main.fa.antwort.a.but configure -font] 4] "0"]]

    $main.fa.frage configure -wraplength $fwrap
    $main.fa.antwort.a.txt configure -wraplength $awrap
    $main.fa.antwort.b.txt configure -wraplength $awrap
    $main.fa.antwort.c.txt configure -wraplength $awrap
    $main.fa.antwort.d.txt configure -wraplength $awrap
    $main.fa.bot configure -wraplength $fwrap
}

proc SaveConfiguration {main} {
    global env base AutoForward fsImmediate cheat scramblea scrambleq
    global tcl_platform tk_version

    if {[catch {set tk_version}] || $tk_version < 8.0} {
	return
    }

    set ffont [lindex [$main.fa.frage configure -font] 4]
    set afont [lindex [$main.fa.antwort.a.txt configure -font] 4]
    lappend ff [font configure $ffont -family]
    lappend ff [font configure $ffont -size]
    lappend ff [font configure $ffont -weight]
    lappend fa [font configure $afont -family]
    lappend fa [font configure $afont -size]
    lappend fa [font configure $afont -weight]
    catch {
	if {$tcl_platform(platform) == "windows"} {
	    set fname [file join $base ppl.ini]
	} else {
	    set fname [file join $env(HOME) .pplrc]
	}
	set f [open $fname w]
	puts $f "# ppl-Konfiguration, [clock format [clock seconds]]"
	puts $f "set ffont {$ff}"
	puts $f "set afont {$fa}"
	puts $f "set fwidth {[lindex [$main.fa.frage configure -width] 4]}"
	puts $f "set fheight {[lindex [$main.fa.frage configure -height] 4]}"
	puts $f "set aheight {[lindex [$main.fa.antwort.a.txt configure -height] 4]}"
	puts $f "set AutoForward $AutoForward"
	puts $f "set fsImmediate $fsImmediate"
	puts $f "set scramblea $scramblea"
	puts $f "set scrambleq $scrambleq"
	puts $f "set cheat $cheat"
	close $f
    }
}

proc SetUpMain {main} {
    global flen alen fwidth ffont afont menu oldMenus
    global tcl_platform fheight aheight kataloge

    if {[info exists tcl_platform(os)] && $tcl_platform(os) == "Windows 95"} {
	set helpLabel "?"
    } else {
	set helpLabel "Hilfe"
    }

    if {$oldMenus} {
	set menu ".menu"

	frame $main.menu -relief raised -bd 2
	menubutton $main.menu.datei -text "Datei" \
		-menu $main.menu.datei.menu -underline 0
	menubutton $main.menu.optionen -text "Optionen" \
		-menu $main.menu.optionen.menu -underline 0
	menubutton $main.menu.katalog -text "Katalog" \
		-menu $main.menu.katalog.menu -underline 0
	menubutton $main.menu.freistil -text "Freistil" \
		-menu $main.menu.freistil.menu -underline 0
	menubutton $main.menu.prfung -text "Prfung" \
		-menu $main.menu.prfung.menu -underline 0
	menubutton $main.menu.help -text "$helpLabel" \
		-menu $main.menu.help.menu -underline 0

	$main.menu.katalog configure -state disabled
	$main.menu.freistil configure -state disabled
	$main.menu.prfung configure -state disabled
    } else {
	set menu ""

	menu $main.menu -tearoff 0
	$main.menu add cascade -label "Datei" \
		-menu $main.menu.datei -underline 0
	$main.menu add cascade -label "Optionen" \
		-menu $main.menu.optionen -underline 0
	$main.menu add cascade -label "Katalog" \
		-menu $main.menu.katalog -underline 0
	$main.menu add cascade -label "Freistil" \
		-menu $main.menu.freistil -underline 0
	$main.menu add cascade -label "Prfung" \
		-menu $main.menu.prfung -underline 0
	$main.menu add cascade -label "$helpLabel" \
		-menu $main.menu.help -underline 0

	$main.menu entryconfigure 2 -state disabled
	$main.menu entryconfigure 3 -state disabled
	$main.menu entryconfigure 4 -state disabled
    }

    menu $main.menu.datei$menu -tearoff 0
    menu $main.menu.optionen$menu -tearoff 0
    menu $main.menu.freistil$menu -tearoff 0
    menu $main.menu.prfung$menu -tearoff 0
    menu $main.menu.help$menu -tearoff 0

    $main.menu.datei$menu add cascade -label "Katalog" \
	    -menu $main.menu.datei[set menu].katalog -underline 0
    $main.menu.datei$menu add command -label "Beenden" -command "Beenden" \
	    -underline 0
    $main.menu.optionen$menu add checkbutton -label "Antworten vertauschen" \
	    -selectcolor black -variable scramblea -underline 0
    $main.menu.optionen$menu add checkbutton -label "Zufllige Fragen" \
	    -selectcolor black -variable scrambleq -underline 0
    $main.menu.optionen$menu add checkbutton -label "Automatisch blttern" \
	    -selectcolor black -variable AutoForward -underline 12
    $main.menu.optionen$menu add checkbutton -label "Antworten verraten" \
	    -selectcolor black -variable cheat -underline 10
    $main.menu.freistil$menu add checkbutton -label "Sofort meckern" \
	    -selectcolor black -variable fsImmediate -underline 0
    $main.menu.freistil$menu add command -label "Auswerten" \
	    -command "Auswerten" -underline 0
    $main.menu.freistil$menu add command -label "Rcksetzen" \
	    -command "WirklichRcksetzen" -underline 0
    $main.menu.prfung$menu add command -label "Auswhlen" \
	    -command "PrfungAuswhlen" -underline 3
    $main.menu.prfung$menu add command -label "Starten" \
	    -command "PrfungStarten" -underline 0
    $main.menu.prfung$menu add command -label "Auswerten" \
	    -command "Auswerten" -underline 0
    $main.menu.prfung$menu add command -label "Rcksetzen" \
	    -command "WirklichRcksetzen" -underline 0

    if {[info exists tcl_platform(os)] && $tcl_platform(os) == "Windows 95"} {
	$main.menu.help$menu add command -label "Hilfethemen" \
		-command "Hilfe" -underline 0
    } else {
	$main.menu.help$menu add command -label "Inhalt" \
		-command "Hilfe" -underline 0
    }
    $main.menu.help$menu add command -label "Allgemeines" \
	    -command "Allgemeines" -underline 0
    $main.menu.help$menu add command -label "Version" -command "Versionen" \
	    -underline 0
    $main.menu.help$menu add command -label "Lizenz" -command "Lizenz" \
	    -underline 0
    $main.menu.help$menu add separator
    $main.menu.help$menu add command -label "ber" -command "About"
    
    menu $main.menu.datei[set menu].katalog -tearoff 0

    foreach kat [lsort [array names kataloge]] {
	$main.menu.datei[set menu].katalog add radiobutton -label $kat \
		-selectcolor black -variable whatkat -value $kat -underline 0
    }

    if {$oldMenus} {
	pack $main.menu.datei $main.menu.optionen $main.menu.katalog \
		$main.menu.freistil $main.menu.prfung -side left
	pack $main.menu.help -side right
	pack $main.menu -side top -fill x
    } else {
	$main configure -menu $main.menu
    }

    frame $main.kataloge
    label $main.kataloge.titel -justify left -anchor w
    frame $main.kataloge.other
    pack $main.kataloge.other -side right
    pack $main.kataloge.titel -fill x -side left -expand true
    
    frame $main.fa -background "#ffffff"
    label $main.fa.frage -width $fwidth -relief sunken -bd 2 -height $fheight \
	    -font $ffont -wraplen $flen -background "#ffffff"
    frame $main.fa.image
    label $main.fa.image.img -anchor center -image ""
    pack  $main.fa.image.img -fill both -expand true
    
    frame $main.fa.antwort
    frame $main.fa.antwort.a -relief raised -bd 1
    frame $main.fa.antwort.b -relief raised -bd 1
    frame $main.fa.antwort.c -relief raised -bd 1
    frame $main.fa.antwort.d -relief raised -bd 1
    
    button $main.fa.antwort.a.but -text "a" -width 3 -command "Antwort a"
    button $main.fa.antwort.b.but -text "b" -width 3 -command "Antwort b"
    button $main.fa.antwort.c.but -text "c" -width 3 -command "Antwort c"
    button $main.fa.antwort.d.but -text "d" -width 3 -command "Antwort d"
    
    label $main.fa.antwort.a.txt -justify left -anchor w -height $aheight \
	    -font $afont -wraplen $alen
    label $main.fa.antwort.b.txt -justify left -anchor w -height $aheight \
	    -font $afont -wraplen $alen
    label $main.fa.antwort.c.txt -justify left -anchor w -height $aheight \
	    -font $afont -wraplen $alen
    label $main.fa.antwort.d.txt -justify left -anchor w -height $aheight \
	    -font $afont -wraplen $alen
    
    pack $main.fa.antwort.a.but -side left -fill y
    pack $main.fa.antwort.b.but -side left -fill y
    pack $main.fa.antwort.c.but -side left -fill y
    pack $main.fa.antwort.d.but -side left -fill y
    pack $main.fa.antwort.a.txt -side right -fill both -expand true
    pack $main.fa.antwort.b.txt -side right -fill both -expand true
    pack $main.fa.antwort.c.txt -side right -fill both -expand true
    pack $main.fa.antwort.d.txt -side right -fill both -expand true
    
    pack $main.fa.antwort.a $main.fa.antwort.b $main.fa.antwort.c \
	    $main.fa.antwort.d -side top -fill both -expand true
    
    label $main.fa.bot -justify left -anchor w -wraplen $flen
    $main.fa.bot configure -bg "#ffffff"

    ConfigureFAFonts $main
    
    pack $main.fa.frage $main.fa.image $main.fa.antwort $main.fa.bot \
	    -side top -fill both -expand true
    
    frame $main.status -relief raised -bd 2
    label $main.status.left -justify left -anchor w  -width 22
    label $main.status.right -justify right -anchor e -width 20
    button $main.status.ff -text ">>" -command "FrageNext 2"
    button $main.status.fw -text "+" -command "FrageNext 1"
    button $main.status.bw -text "-" -command "FrageNext -1"
    button $main.status.fb -text "<<" -command "FrageNext -2"
    pack $main.status.left -fill x -side left -expand true
    pack $main.status.ff $main.status.fw $main.status.bw $main.status.fb \
	    -side right -padx 2 -pady 2
    pack $main.status.right -side right

    pack $main.kataloge -side top -fill x
    pack $main.status -side bottom -fill x -pady 2
    pack $main.fa -expand true -fill both

    bind $main <Key-a> "Antwort a"
    bind $main <Key-b> "Antwort b"
    bind $main <Key-c> "Antwort c"
    bind $main <Key-d> "Antwort d"
    
    #
    # Verhindere, da bei <Alt-d> auch <Key-d> getriggert wird.
    #
    
    bind $main <Alt-d> {
	# nop
    }
    
    bind $main <Key-greater> "FrageNext  2"
    bind $main <Key-plus>    "FrageNext  1"
    bind $main <Key-minus>   "FrageNext -1"
    bind $main <Key-less>    "FrageNext -2"

    bind $main <Key-Prior>   "FrageNext -2"
    bind $main <Key-Left>    "FrageNext -1"
    bind $main <Key-Right>   "FrageNext  1"
    bind $main <Key-Next>    "FrageNext  2"

    bind $main <Key-F1>      "Hilfe"

    bind $main.fa.frage <Button-3> ConfigureFonts
    bind $main.fa.antwort.a.txt <Button-3> ConfigureFonts
    bind $main.fa.antwort.b.txt <Button-3> ConfigureFonts
    bind $main.fa.antwort.c.txt <Button-3> ConfigureFonts
    bind $main.fa.antwort.d.txt <Button-3> ConfigureFonts
}

proc ChangeKatalog {n1 n2 op} {
    global main whatkat whatppl status kataloge

    WirklichRcksetzen

    if {$status != 0} {
	return
    }

    wm title $main [lindex $kataloge($whatkat) 0]
    InitKataloge   [lindex $kataloge($whatkat) 1]
    set whatppl    [lindex $kataloge($whatkat) 2]
}

proc SetUpTraces {} {
    global cheat fsImmediate whatkat

    proc cheatTrace {n1 n2 op} {
	ShowFrage
    }

    proc fsITrace {n1 n2 op} {
	global status fsImmediate main menu
	if {$status == 1 && $fsImmediate == 1} {
	    $main.menu.freistil$menu entryconfigure 0 -state disabled
	    $main.status.left configure -text "Freistil (Sofort)"
	    ShowFrage
	}
    }

    catch {trace vdelete cheat w cheatTrace}
    catch {trace vdelete fsImmediate w fsITrace}
    catch {trace vdelete whatkat w ChangeKatalog}
    
    trace variable cheat w cheatTrace
    trace variable fsImmediate w fsITrace
    trace variable whatkat w ChangeKatalog
}

#
# ----------------------------------------------------------------------
# Fonts konfigurieren
# ----------------------------------------------------------------------
#

proc SelectFont {theent pm} {
    global fontlist
#
# On Windows, there may be more than one font with the same name!? Sigh.
#
    if {![info exists fontlist]} {
	set oldf ""
	foreach font [lsort [font families]] {
	    if {$oldf == [string tolower $font]} {
		continue
	    }
	    lappend fontlist [set oldf [string tolower $font]]
	}
    }
    set curf  [string tolower [$theent get]]
    set numf  [llength $fontlist]
    set curfn -1

    for {set i 0} {$i < $numf} {incr i} {
	if {$curf == [lindex $fontlist $i]} {
	    set curfn $i
	    break
	}
    }

    if {$curfn == -1} {
	if {$pm < 0} {
	    set curfn [expr $numf - 1]
	} else {
	    set curfn 0
	}
    } else {
	if {$pm < 0} {
	    set curfn [expr $curfn - 1]
	    if {$curfn < 0} {
		set curfn [expr $numf - 1]
	    }
	} else {
	    incr curfn
	    if {$curfn >= $numf} {
		set curfn 0
	    }
	}
    }

    set newf [lindex $fontlist $curfn]
    set newf "[string toupper [string index $newf 0]][string range $newf 1 end]"
    $theent delete 0 end
    $theent insert 0 $newf
}

proc SelectStyle {theent} {
    set curs [string tolower [$theent get]]
    if {$curs == "bold"} {
	set curs "normal"
    } elseif {$curs == "normal"} {
	set curs "bold"
    } else {
	set curs "normal"
    }
    $theent delete 0 end
    $theent insert 0 $curs
}

proc ConfigureFonts {} {
    global main tk_version ffont afont fwidth

    if {[catch {set tk_version}] || $tk_version < 8.0} {
	return
    }

    if {[catch {toplevel .fc}]} {
	return
    }
    
    wm title .fc "Einstellungen Fonts"

    frame .fc.ff
    label .fc.ff.lab -text "Font Frage" -width 16
    entry .fc.ff.font -width 20
    entry .fc.ff.size -width 5
    entry .fc.ff.style -width 8
    pack .fc.ff.lab .fc.ff.font .fc.ff.size .fc.ff.style -side left
    pack .fc.ff -side top

    .fc.ff.font insert 0 [font configure $ffont -family]
    .fc.ff.size insert 0 [font configure $ffont -size]
    .fc.ff.style insert 0 [font configure $ffont -weight]

    frame .fc.fa
    label .fc.fa.lab -text "Font Antwort" -width 16
    entry .fc.fa.font -width 20
    entry .fc.fa.size -width 5
    entry .fc.fa.style -width 8
    pack .fc.fa.lab .fc.fa.font .fc.fa.size .fc.fa.style -side left
    pack .fc.fa -side top

    .fc.fa.font insert 0 [font configure $afont -family]
    .fc.fa.size insert 0 [font configure $afont -size]
    .fc.fa.style insert 0 [font configure $afont -weight]

    frame .fc.w
    label .fc.w.lab -text "Breite" -width 16
    entry .fc.w.ent -width 20
    pack .fc.w.lab .fc.w.ent -side left
    pack .fc.w -side top

    .fc.w.ent insert 0 [lindex [$main.fa.frage configure -width] 4]

    frame .fc.h
    label .fc.h.lab -text "Hhe F/A" -width 16
    entry .fc.h.ef -width 10
    entry .fc.h.ea -width 10
    pack .fc.h.lab .fc.h.ef .fc.h.ea -side left
    pack .fc.h -side top

    .fc.h.ef insert 0 [lindex [$main.fa.frage configure -height] 4]
    .fc.h.ea insert 0 [lindex [$main.fa.antwort.a.txt configure -height] 4]

    frame .fc.bot
    button .fc.bot.b1 -text "Anwenden" -command {
	global main ffont afont

	font configure $ffont -family [.fc.ff.font get] \
		-size [.fc.ff.size get] \
		-weight [.fc.ff.style get]
	font configure $afont -family [.fc.fa.font get] \
		-size [.fc.fa.size get] \
		-weight [.fc.fa.style get]
	$main.fa.frage configure -font $ffont \
		-width [.fc.w.ent get] -height [.fc.h.ef get]
	$main.fa.antwort.a.txt configure -font $afont -height [.fc.h.ea get]
	$main.fa.antwort.b.txt configure -font $afont -height [.fc.h.ea get]
	$main.fa.antwort.c.txt configure -font $afont -height [.fc.h.ea get]
	$main.fa.antwort.d.txt configure -font $afont -height [.fc.h.ea get]
	ConfigureFAFonts $main
    }
    button .fc.bot.b3 -text "Speichern" -command {
	global $main
	.fc.bot.b1 invoke
	SaveConfiguration $main
    }
    button .fc.bot.b2 -text "Schlieen" -command "destroy .fc"
    pack .fc.bot.b1 .fc.bot.b3 .fc.bot.b2 -side left -fill x -expand true
    pack .fc.bot -side bottom
    bind .fc <Key-Return> ".fc.bot.b1 invoke"
    bind .fc.ff.font  <Button-3> "SelectFont  .fc.ff.font 1"
    bind .fc.ff.lab   <Button-3> "SelectFont  .fc.ff.font 1"
    bind .fc.ff.style <Button-3> "SelectStyle .fc.ff.style"
    bind .fc.fa.font  <Button-3> "SelectFont  .fc.fa.font 1"
    bind .fc.fa.lab   <Button-3> "SelectFont  .fc.fa.font 1"
    bind .fc.fa.style <Button-3> "SelectStyle .fc.fa.style"
}

#
# ----------------------------------------------------------------------
# Handhabung des Fragenkataloges
# ----------------------------------------------------------------------
#

proc Rcksetzen {} {
    global antworten fliste flindex fcount main katalog status
    global images KatList menu oldMenus

    foreach image [array names images] {
	image delete $images($image)
    }

    catch {destroy .auswertung}
    catch {destroy .rev}
    catch {unset antworten}
    catch {unset fliste}
    catch {unset flindex}
    catch {unset fcount}
    catch {unset images}
    catch {unset scramble}

    set katalog ""
    set status 0

    if {$oldMenus} {
	if {[llength $KatList] > 0} {
	    $main.menu.katalog configure -state normal
	    $main.menu.freistil configure -state normal
	    $main.menu.prfung configure -state normal
	} else {
	    $main.menu.katalog configure -state disabled
	    $main.menu.freistil configure -state disabled
	    $main.menu.prfung configure -state disabled
	}
    } else {
	if {[llength $KatList] > 0} {
	    $main.menu entryconfigure 2 -state normal
	    $main.menu entryconfigure 3 -state normal
	    $main.menu entryconfigure 4 -state normal
	} else {
	    $main.menu entryconfigure 2 -state disabled
	    $main.menu entryconfigure 3 -state disabled
	    $main.menu entryconfigure 4 -state disabled
	}
    }

    set i 1
    foreach kat $KatList {
	$main.kataloge.other.$kat configure -relief raised
	$main.menu.katalog$menu entryconfigure $i -state normal
	incr i
    }

    $main.kataloge.titel configure -text ""
    $main.menu.freistil$menu entryconfigure 0 -state normal
    $main.status.left configure -text "Okay"

    ShowFrage
}

proc InitKataloge { kapitel } {
    global KatList main frage data menu

    set KatList ""

    foreach kat $kapitel {
	set name  [lindex [split $kat ,] 0]
	set fname [lindex [split $kat ,] 1]

	if {$fname == ""} {
	    set file [file join $data [set name].qn]
	} else {
	    set file [file join $data [set fname].qn]
	}
	if {![file isfile $file]} {
	    continue
	}
	if {![file readable $file]} {
	    continue
	}
	if {[lsearch -exact $KatList $name] == -1} {
	    lappend KatList $name
	}
	if {[catch {set line [open $file]}]} {
	    continue
	}
	if {[catch {set frage($name,title) [gets $line]}]} {
	    close $line
	    continue
	}
	if {[catch {set frage($name,rev) [gets $line]}]} {
	    close $line
	    continue
	}
	if {[catch {set frage($name,loaded)}]} {
	    set frage($name,loaded) 0
	    set frage($name,file) $file
	}
	close $line
    }

    catch {eval destroy [pack slaves $main.kataloge.other]}
    catch {destroy $main.menu.katalog$menu}
    menu $main.menu.katalog$menu

    set KatList [lsort $KatList]

    foreach kat $KatList {
	button $main.kataloge.other.$kat -text $kat -command "SwitchToKat $kat"
	pack $main.kataloge.other.$kat -side left -fill x -expand true
	$main.menu.katalog$menu add command -label $frage($kat,title) \
		-command "SwitchToKat $kat"
    }

    Rcksetzen
}

proc LoadKatalog {kat} {
    global main frage

    if {$frage($kat,loaded) == 0} {
	set text [lindex [$main.status.left configure -text] 4]
	set curs [lindex [$main configure -cursor] 4]
	$main.status.left configure -text "Lade $frage($kat,title) ..."
	$main.status.right configure -text ""
	$main configure -cursor watch
	update
	loadq $kat $frage($kat,file)
	$main.status.left configure -text $text
	$main configure -cursor $curs
	set frage($kat,loaded) 1
    }
}

proc SelectFragen {kat} {
    global fliste flindex fcount frage whatppl main
    global scramble scramblea scrambleq

    LoadKatalog $kat

    if {[catch {set fliste($kat)}]} {
	set fliste($kat) ""
    }
    if {$fliste($kat) == ""} {
	if {[catch {set numq $fcount($kat)}]} {
	    set numq $frage($kat,count)
	}

	for {set i 0} {$i < $frage($kat,count)} {incr i} {
	    lappend lf $i
	}

	set j 0

	while {$j < $numq} {
	    if {[llength $lf] == 0} {
		break
	    }
	    if {$scrambleq} {
		set nn [rand [llength $lf]]
	    } else {
		set nn 0
	    }
	    set q  [lindex $lf $nn]
	    set lf "[lrange $lf 0 [expr $nn-1]] [lrange $lf [expr $nn+1] end]"

	    if {$frage($kat,$q) == "-"} {
		continue
	    }

	    if {![catch {set frage($kat,$q,rel)}]} {
		if {[string first $whatppl $frage($kat,$q,rel)] == -1} {
		    continue
		}
	    }

	    if {$frage($kat,$q,a) == "a)"} {
		set scramble($kat,$q) 0
	    } elseif {$scramblea} {
		set scramble($kat,$q) [rand 24]
	    } else {
		set scramble($kat,$q) 0
	    }

	    lappend f $q
	    incr j
	}

	set fliste($kat) $f
	set fcount($kat) $j
	set flindex($kat) 0
    }
    return $fcount($kat)
}

#
# ----------------------------------------------------------------------
# stndig aktive Hauptfunktionen
# ----------------------------------------------------------------------
#

proc ShowFrage {} {
    global katalog frage antwort fliste flindex main images img
    global antworten status fsImmediate fcount cheat scramble perm
    global ImgExtThres oldGeometry imgcache

    set txtdefcol [lindex [$main.fa.antwort.a.txt configure -bg] 3]

    if {$katalog == ""} {
	$main.fa.frage configure -text ""
	$main.fa.antwort.a.txt configure -bg $txtdefcol -text ""
	$main.fa.antwort.b.txt configure -bg $txtdefcol -text ""
	$main.fa.antwort.c.txt configure -bg $txtdefcol -text ""
	$main.fa.antwort.d.txt configure -bg $txtdefcol -text ""
	$main.fa.antwort.a.but configure -relief raised
	$main.fa.antwort.b.but configure -relief raised
	$main.fa.antwort.c.but configure -relief raised
	$main.fa.antwort.d.but configure -relief raised
	$main.status.right configure -text ""

	catch {destroy $main.image}
	$main.fa.image.img configure -image ""
	$main.fa.bot configure -text ""
	return
    }

    set kat $katalog

    set i  ""
    set q  [lindex $fliste($kat) $flindex($kat)]
    set tf $frage($kat,$q)
    regexp {\[([^]]*)]} $tf dummy i
    regsub { *\[([^]]*)] *} $tf " " tf

    regsub -all {<br>}       $tf " " tf
    regsub -all {</?p[^>]*>} $tf " " tf

    if {![catch {set frage($kat,$q,imgr)}]} {
	set i $frage($kat,$q,imgr)
    } elseif {![catch {set frage($kat,$q,img)}]} {
	set i $frage($kat,$q,img)
    }

    catch {
	set oldGeometry [wm geometry $main.image]
    }

    if {$i != ""} {
	set text [lindex [$main.status.left configure -text] 4]
	set curs [lindex [$main configure -cursor] 4]
	$main.status.left configure -text "Lade Bild zur Frage ..."
	$main configure -cursor watch
	update

	if {![info exists images($i)]} {
	    catch {
		set images($i) [image create photo -file [file join $img $i]]
	    }
	}

	if {[info exists images($i)]} {
	    if {[image height $images($i)] > $ImgExtThres} {
		if {[catch {pack info $main.image.img}]} {
		    catch {destroy $main.image}
		    toplevel $main.image -bg "#ffffff"
		    label $main.image.img
		    pack $main.image.img
		    catch {
			if {[info exists oldGeometry]} {
			    set tmp [split $oldGeometry +]
			    set oxp [lindex $tmp 1]
			    set oyp [lindex $tmp 2]
			    if {$oxp < 10} {set oxp 10}
			    if {$oyp < 10} {set oyp 10}
			    set nG  "+$oxp+$oyp"
			    wm geometry $main.image $nG
			}
		    }
		} else {
		    wm deiconify $main.image
		}
		wm title $main.image "Frage [expr $q + 1]"
		$main.image.img configure -image $images($i)
		$main.fa.image.img configure -image ""
	    } else {
		catch {$main.image.img configure -image ""}
		catch {wm title $main.image "Keine Grafik"}
		catch {destroy $main.image}
		$main.fa.image.img configure -image $images($i)
	    }
	} else {
	    catch {$main.image.img configure -image ""}
	    catch {wm title $main.image "Kann Grafik nicht laden"}
	    catch {destroy $main.image}
	    $main.fa.image.img configure -image ""
	}
	$main.status.left configure -text $text
	$main configure -cursor $curs

	if {$imgcache == 0} {
	    foreach ti [array names images] {
		if {$ti != $i} {
		    image delete $images($ti)
		    unset images($ti)
		}
	    }
	}
    } else {
	catch {$main.image.img configure -image ""}
	catch {wm title $main.image "Keine Grafik"}
	catch {destroy $main.image}
	$main.fa.image.img configure -image ""
    }

    if {![catch {set frage($kat,$q,bot)}]} {
	$main.fa.bot configure -text $frage($kat,$q,bot)
    } else {
	$main.fa.bot configure -text ""
    }

    $main.fa.frage configure -text $tf
    $main.fa.antwort.$perm($scramble($kat,$q),a).txt configure \
	    -bg $txtdefcol -text $frage($kat,$q,a)
    $main.fa.antwort.$perm($scramble($kat,$q),b).txt configure \
	    -bg $txtdefcol -text $frage($kat,$q,b)
    $main.fa.antwort.$perm($scramble($kat,$q),c).txt configure \
	    -bg $txtdefcol -text $frage($kat,$q,c)
    $main.fa.antwort.$perm($scramble($kat,$q),d).txt configure \
	    -bg $txtdefcol -text $frage($kat,$q,d)
    $main.fa.antwort.a.but configure -relief raised
    $main.fa.antwort.b.but configure -relief raised
    $main.fa.antwort.c.but configure -relief raised
    $main.fa.antwort.d.but configure -relief raised

    if {![catch {set antworten($kat,$q)}]} {
	$main.fa.antwort.$antworten($kat,$q).but configure -relief sunken
    }

    if {$cheat} {
	$main.fa.antwort.$perm($scramble($kat,$q),$antwort($kat,$q)).txt \
		configure -bg "#00ff00"
    }

    if {$status == 2 || ($status == 1 && $fsImmediate)} {
	if {![catch {set antworten($kat,$q)}]} {
	    if {$antworten($kat,$q) == "a" || \
		    $antworten($kat,$q) == "b" || \
		    $antworten($kat,$q) == "c" || \
		    $antworten($kat,$q) == "d"} {
		$main.fa.antwort.$antworten($kat,$q).txt \
			configure -bg "#ff0000"
		$main.fa.antwort.$perm($scramble($kat,$q),$antwort($kat,$q)).txt \
			configure -bg "#00ff00"
	    }
	}
    } elseif {$status == 4} {
	if {![catch {set antworten($kat,$q)}]} {
	    if {$antworten($kat,$q) == "a" || \
		    $antworten($kat,$q) == "b" || \
		    $antworten($kat,$q) == "c" || \
		    $antworten($kat,$q) == "d"} {
		$main.fa.antwort.$antworten($kat,$q).txt \
			configure -bg "#ff0000"
	    }
	}
	$main.fa.antwort.$perm($scramble($kat,$q),$antwort($kat,$q)).txt \
		configure -bg "#00ff00"
    }

    $main.status.right configure -text "Frage [expr $q + 1] ([expr $flindex($kat) + 1]/$fcount($kat))"
}

proc NextKatalog {kat} {
    global KatList

    set tk 0
    foreach item $KatList {
	if {$tk == 1} {
	    return $item
	} elseif {$kat == $item} {
	    set tk 1
	}
    }
    return [lindex $KatList 0]
}

proc PrevKatalog {kat} {
    global KatList

    set tk ""
    foreach item $KatList {
	if {$kat == $item} {
	    if {$tk != ""} {
		return $tk
	    }
	}
	set tk $item
    }
    return $tk
}

proc FrageVorwrts {} {
    global fliste flindex fcount status katalog

    set kat $katalog

    if {[expr $flindex($kat) + 1] < $fcount($kat)} {
	incr flindex($kat)
    } else {
	if {$status == 1} {
	    set nk [NextKatalog $kat]
	    SelectFragen $nk
	} else {
	    set nk $kat
	    while {42} {
		set nk [NextKatalog $nk]
		if {[catch {set fcount($nk)}]} {
		    continue
		}
		if {$fcount($nk) > 0} {
		    break
		}
	    }
	}
	set flindex($nk) 0
	SwitchToKat $nk
    }
}

proc FrageRckwrts {} {
    global fliste flindex fcount status katalog

    set kat $katalog

    if {$flindex($kat) > 0} {
	set flindex($kat) [expr $flindex($kat) - 1]
    } else {
	if {$status == 1} {
	    set nk [PrevKatalog $kat]
	    SelectFragen $nk
	} else {
	    set nk $kat
	    while {42} {
		set nk [PrevKatalog $nk]
		if {[catch {set fcount($nk)}]} {
		    continue
		}
		if {$fcount($nk) > 0} {
		    break
		}
	    }
	}
	set flindex($nk) [expr $fcount($nk) - 1]
	SwitchToKat $nk
    }
}

proc FalscheFrageVorwrts {} {
    global fliste flindex fcount status katalog antworten antwort
    global scramble perm

    set kat $katalog

    # wenn status==1 oder status==3, naechste unbeantwortete Frage
    # wenn status==2, nchste falsche Frage
    # wenn status==4, nchste unbeantwortete oder falsche Frage
    # wenn status==2 oder status==4, naechste falsche Frage

    set index  [expr $flindex($kat) + 1]
    set curkat $kat
    set around 0
    set res    0

    while {42} {
	while {$index < $fcount($curkat)} {
	    set q [lindex $fliste($curkat) $index]
	    
	    if {$status == 1 || $status == 3} {
		if {[catch {set antworten($curkat,$q)}]} {
		    set res 1
		}
	    } elseif {$status == 2} {
		if {![catch {set antworten($curkat,$q)}] && \
			$antworten($curkat,$q) != $perm($scramble($curkat,$q),$antwort($curkat,$q))} {
		    set res 1
		}
	    } else {
		if {[catch {set antworten($curkat,$q)}] || \
			$antworten($curkat,$q) != $perm($scramble($curkat,$q),$antwort($curkat,$q))} {
		    set res 1
		}
	    }
	    if {$res == 1} {
		set flindex($curkat) $index
		if {$curkat != $kat} {
		    SwitchToKat $curkat
		}
		return
	    }
	    incr index
	}
	
	if {$curkat == $kat && $around} {
	    return
	}
	
	if {$status == 1} {
	    set curkat [NextKatalog $curkat]
	    SelectFragen $curkat
	} else {
	    while {42} {
		set curkat [NextKatalog $curkat]
		if {[catch {set fcount($curkat)}]} {
		    continue
		}
		if {$fcount($curkat) > 0} {
		    break
		}
	    }
	}
	
	set index  0
	
	if {$curkat == $kat} {
	    set around 1
	}
    }
}

proc FalscheFrageRckwrts {} {
    global fliste flindex fcount status katalog antworten antwort
    global scramble perm

    set kat $katalog

    # wenn status==1 oder status==3, vorige unbeantwortete Frage
    # wenn status==2, vorige falsche Frage
    # wenn status==4, vorige unbeantwortete oder falsche Frage

    set index  [expr $flindex($kat) - 1]
    set curkat $kat
    set around 0
    set res    0

    while {42} {
	while {$index >= 0} {
	    set q [lindex $fliste($curkat) $index]

	    if {$status == 1 || $status == 3} {
		if {[catch {set antworten($curkat,$q)}]} {
		    set res 1
		}
	    } elseif {$status == 2} {
		if {![catch {set antworten($curkat,$q)}] && \
			$antworten($curkat,$q) != $perm($scramble($curkat,$q),$antwort($curkat,$q))} {
		    set res 1
		}
	    } else {
		if {[catch {set antworten($curkat,$q)}] || \
			$antworten($curkat,$q) != $perm($scramble($curkat,$q),$antwort($curkat,$q))} {
		    set res 1
		}
	    }
	    if {$res == 1} {
		set flindex($curkat) $index
		if {$curkat != $kat} {
		    SwitchToKat $curkat
		}
		return
	    }
	    set index [expr $index - 1]
	}
	
	if {$curkat == $kat && $around} {
	    return
	}
	
	if {$status == 1} {
	    set curkat [PrevKatalog $curkat]
	    SelectFragen $curkat
	} else {
	    while {42} {
		set curkat [PrevKatalog $curkat]
		if {[catch {set fcount($curkat)}]} {
		    continue
		}
		if {$fcount($curkat) > 0} {
		    break
		}
	    }
	}
	
	set index [expr $fcount($curkat) - 1]
	
	if {$curkat == $kat} {
	    set around 1
	}
    }
}

proc FrageNext {i} {
    global status katalog

    set kat $katalog

    if {$status == "0"} {
	return
    }

    if {$i == "1"} {
	FrageVorwrts
    } elseif {$i == "-1"} {
	FrageRckwrts
    } elseif {$i == "2"} {
	FalscheFrageVorwrts
    } elseif {$i == "-2"} {
	FalscheFrageRckwrts
    }
    ShowFrage
}

proc Antwort {aw} {
    global fliste flindex antworten antwort katalog main status
    global fsImmediate AutoForward scramble perm menu

    if {$status == 0 || $status == 2 || $status == 4} {
	return
    }

    set kat $katalog
    set q   [lindex $fliste($kat) $flindex($kat)]

    if {$status == 1 && $fsImmediate} {
	if {![catch {set antworten($kat,$q)}]} {
	    return
	}
	$main.menu.freistil$menu entryconfigure 0 -state disabled
    }

    set antworten($kat,$q) $aw

    $main.fa.antwort.a.but configure -relief raised
    $main.fa.antwort.b.but configure -relief raised
    $main.fa.antwort.c.but configure -relief raised
    $main.fa.antwort.d.but configure -relief raised
    $main.fa.antwort.$aw.but configure -relief sunken

    if {$status == 1 && $fsImmediate} {
	$main.fa.antwort.$aw.txt configure -bg "#ff0000"
	$main.fa.antwort.$perm($scramble($kat,$q),$antwort($kat,$q)).txt configure -bg "#00ff00"

	if {$aw == $perm($scramble($kat,$q),$antwort($kat,$q))} {
	    if {$AutoForward} {
		FrageNext 1
	    }
	}
    } else {
	if {$AutoForward} {
	    FrageNext 1
	}
    }
}

proc SwitchToKat {kat} {
    global fliste flindex status fcount frage main katalog fsImmediate
    global menu oldMenus

    if {$status == 0} {
	set status 1
	if {$oldMenus} {
	    $main.menu.prfung configure -state disabled
	} else {
	    $main.menu entryconfigure 4 -state disabled
	}
	if {$fsImmediate == 1} {
	    $main.status.left configure -text "Freistil (Sofort)"
	    $main.menu.freistil$menu entryconfigure 0 -state disabled
	} else {
	    $main.status.left configure -text "Freistil"
	}
    }

    foreach dep [pack slaves $main.kataloge.other] {
	$dep configure -relief raised
    }

    LoadKatalog $kat

    $main.kataloge.other.$kat configure -relief sunken
    $main.kataloge.titel configure -text $frage($kat,title)

    set katalog $kat
    SelectFragen $kat
    ShowFrage
}

#
# ----------------------------------------------------------------------
# Gemeinsame Menfunktionen
# ----------------------------------------------------------------------
#

proc Auswerten {} {
    global antworten fliste flindex fcount main status
    global KatList antwort frage paktiv scramble perm

    if {$status == 0} {
	return
    }

    if {$status == 1} {
	set status 2
    } elseif {$status == 3} {
	set status 4
    }

    ShowFrage

    if {[catch {toplevel .auswertung}]} {
	return
    }

    wm title .auswertung "Auswertung"

    frame .auswertung.top -relief raised -bd 2
    label .auswertung.top.title   -text "Gebiet"
    label .auswertung.top.gesamt  -text "Gesamt"  -width 10
    label .auswertung.top.richtig -text "Richtig" -width 10
    label .auswertung.top.falsch  -text "Falsch"  -width 10
    label .auswertung.top.prozent -text "Prozent" -width 10

    pack .auswertung.top.title -side left -fill x -expand true
    pack .auswertung.top.gesamt \
	    .auswertung.top.richtig .auswertung.top.falsch \
	    .auswertung.top.prozent -side left
    pack .auswertung.top -side top -fill x
    update

    set tr 0
    set tf 0
    set tt 0

    foreach kat $KatList {
	set r 0
	set f 0
	set t 0

	if {$status == 2} {
	    foreach list [array names antworten $kat,*] {
		set q [lindex [split $list ,] 1]
		
		if {$antworten($kat,$q) == $perm($scramble($kat,$q),$antwort($kat,$q))} {
		    incr r
		} else {
		    incr f
		}
		incr t
	    }
	} else {
	    if {$fliste($kat) == ""} {
		continue
	    }
	    foreach q $fliste($kat) {
		if {[catch {set antworten($kat,$q)}]} {
		    incr f
		} elseif {$antworten($kat,$q) == $perm($scramble($kat,$q),$antwort($kat,$q))} {
		    incr r
		} else {
		    incr f
		}
		incr t
	    }
	}

	if {$t == 0} {
	    continue
	}

	set pc [expr round(100.0*double($r)/$t)]

	if {$pc < 75} {
	    set col "#ff0000"
	} elseif {$pc < 85} {
	    set col "#ffff00"
	} else {
	    set col "#00ff00"
	}

	frame .auswertung.$kat -relief sunken
	label .auswertung.$kat.title    -bg $col -text $frage($kat,title)
	label .auswertung.$kat.gesamt   -bg $col -text $t -width 10
	label .auswertung.$kat.richtig  -bg $col -text $r -width 10
	label .auswertung.$kat.falsch   -bg $col -text $f -width 10
	label .auswertung.$kat.prozent  -bg $col -text "$pc%" -width 10

	pack .auswertung.$kat.title -side left -fill x -expand true
	pack .auswertung.$kat.gesamt \
		.auswertung.$kat.richtig .auswertung.$kat.falsch \
		.auswertung.$kat.prozent -side left -fill x
	pack .auswertung.$kat -side top -fill x
	update

	set tr [expr $tr + $r]
	set tf [expr $tf + $f]
	set tt [expr $tt + $t]
    }

    if {$tt == 0} {
	set pc "100"
    } else {
	set pc [expr round(100.0*double($tr)/$tt)]
    }

    if {$pc < 75} {
	set col "#ff0000"
    } elseif {$pc < 85} {
	set col "#ffff00"
    } else {
	set col "#00ff00"
    }

    frame .auswertung.bot -relief sunken
    label .auswertung.bot.title   -bg $col -text "Gesamt"
    label .auswertung.bot.gesamt  -bg $col -text $tt -width 10
    label .auswertung.bot.richtig -bg $col -text $tr -width 10
    label .auswertung.bot.falsch  -bg $col -text $tf -width 10
    label .auswertung.bot.prozent -bg $col -text "$pc%" -width 10

    pack .auswertung.bot.title -side left -fill x -expand true
    pack .auswertung.bot.gesamt \
	    .auswertung.bot.richtig .auswertung.bot.falsch \
	    .auswertung.bot.prozent -side left -fill x
    pack .auswertung.bot -side top -fill x
    
    frame .auswertung.cb -relief raised
    button .auswertung.cb.b1 -text "Schlieen" -command "destroy .auswertung"
    button .auswertung.cb.b2 -text "Rcksetzen" -command "Rcksetzen"
    pack .auswertung.cb.b1 .auswertung.cb.b2 -side left -fill x -expand true
    pack .auswertung.cb -fill x

    focus .auswertung.cb.b2
    bind .auswertung <Key-Return> "Rcksetzen"

    if {$status == 2} {
	$main.status.left configure \
		-text "Freistil (Ausgewertet)"
    } else {
	$main.status.left configure \
		-text "Prfung (Ausgewertet)"
    }
}

proc WirklichRcksetzen {} {
    global antworten fliste flindex fcount main katalog status

    if {$status == 0} {
	return
    }

    if {$status == 2 || $status == 4} {
	Rcksetzen
	return
    }

    if {$status == 1} {
	if {[catch {set res [tk_dialog .dialog {Wirklich Rcksetzen?} \
		"Wollen Sie die Freistil-Sitzung wirklich\
		ohne Auswertung beenden?" questhead 0 Ja Nein]}]} {
	    return
	}
    } else {
	if {[catch {set res [tk_dialog .dialog {Wirklich Rcksetzen?} \
		"Wollen Sie die Prfung wirklich\
		ohne Auswertung beenden?" questhead 0 Ja Nein]}]} {
	    return
	}
    }

    if {$res == 0} {
	Rcksetzen
    }
}

#
# ----------------------------------------------------------------------
# Menfunktionen Prfung
# ----------------------------------------------------------------------
#

proc PrfAuswahlKatBut {kat} {
    global fcount pcount paktiv PDefAnz

    if {$paktiv($kat) == 0} {
	if {$pcount($kat) == 0} {
	    set pcount($kat) $PDefAnz
	}
	set paktiv($kat) 1
	.prf.$kat.aktiv configure -relief sunken -text ja
	.prf.$kat.frage configure -state normal -foreground \
		[lindex [.prf.$kat.frage configure -foreground] 3]
    } else {
	if {$pcount($kat) == 0} {
	    set pcount($kat) $PDefAnz
	}
	set paktiv($kat) 0
	.prf.$kat.aktiv configure -relief raised -text nein
	.prf.$kat.frage configure -state disabled -foreground \
		[lindex [.prf.$kat.frage configure -background] 4]
    }
}

proc PrfungStarten {} {
    global fcount pcount paktiv main KatList status frage
    global PDefAnz fliste menu oldMenus

    if {$status == 1 || $status == 3} {
	if {[catch {set res [tk_dialog .dialog {Wollen Sie Rcksetzen?} \
		"Wollen Sie wirklich Rcksetzen und eine neue Prfung\
		starten?" questhead 1 Ja Nein]}]} {
	    return
	}
	if {$res == 1} {
	    return
	}
    }

    set total 0

    foreach kat $KatList {
	if {[catch {set paktiv($kat)}]} {
	    set paktiv($kat) 1
	}
	if {[catch {set pcount($kat)}]} {
	    set pcount($kat) $PDefAnz
	}
	if {$pcount($kat) == ""} {
	    set pcount($kat) 0
	}
	if {$pcount($kat) == 0} {
	    set paktiv($kat) 0
	    set pcount($kat) $PDefAnz
	}
	if {$paktiv($kat)} {
	    set total [expr $total + $pcount($kat)]
	}
    }
    if {$total == 0} {
	catch {set res [tk_dialog .dialog {Keine Fragen Ausgewhlt} \
		"Bitte whlen Sie erst aus, ber welche Fragenkataloge\
		Sie geprft werden wollen." warning 0 OK]}
	PrfungAuswhlen
	return
    }

    $main.status.left configure -text "Prfung startet ..."
    catch {destroy .prf}
    update

    set i 1
    foreach kat $KatList {
	if {$paktiv($kat)} {
	    if {[catch {set firstkat}]} {
		set firstkat $kat
	    }
	    set fcount($kat) $pcount($kat)
	    set fliste($kat) ""
	    $main.kataloge.other.$kat configure -state normal
	    $main.menu.katalog$menu entryconfigure $i -state normal
	} else {
	    set fcount($kat) 0
	    set fliste($kat) ""
	    $main.kataloge.other.$kat configure -state disabled
	    $main.menu.katalog$menu entryconfigure $i -state disabled
	}
	incr i
    }
    $main.status.left configure -text "Prfung"
    if {$oldMenus} {
	$main.menu.freistil configure -state disabled
    } else {
	$main.menu entryconfigure 3 -state disabled
    }
    set status 3
    SwitchToKat $firstkat
}

proc PrfungAuswhlen {} {
    global fcount pcount paktiv main KatList status frage
    global PDefAnz

    if {[catch {toplevel .prf}]} {
	foreach kat $KatList {
	    if {$pcount($kat) == ""} {
		set pcount($kat) 0
	    }
	    if {$pcount($kat) == 0} {
		set paktiv($kat) 0
		set pcount($kat) $PDefAnz
	    }
	    if {$paktiv($kat) == 0} {
		.prf.$kat.aktiv configure -relief raised -text nein
		.prf.$kat.frage configure -state disabled -foreground \
			[lindex [.prf.$kat.frage configure -background] 4]
	    } else {
		.prf.$kat.aktiv configure -relief sunken -text ja
		.prf.$kat.frage configure -state normal -foreground \
			[lindex [.prf.$kat.frage configure -foreground] 3]
	    }
	}
	return
    }
    wm title .prf "Auswahl Fragen fr Prfung"

    frame .prf.top -relief raised -bd 2
    label .prf.top.aktiv  -text "Aktiv"    -width 10
    label .prf.top.title  -text "Gebiet"
    label .prf.top.gesamt -text "Gesamt"   -width 10
    label .prf.top.frage  -text "Abfragen" -width 10

    pack .prf.top.aktiv -side left -padx 2
    pack .prf.top.title -side left -padx 2 -fill x -expand true
    pack .prf.top.gesamt .prf.top.frage -side left -padx 2
    pack .prf.top -side top -fill x

    foreach kat $KatList {
	if {[catch {set paktiv($kat)}]} {
	    set paktiv($kat) 1
	}

	if {[catch {set pcount($kat)}]} {
	    set pcount($kat) $PDefAnz
	}

	if {[catch {set frage($kat,count)}]} {
	    set tc ""
	} else {
	    set tc $frage($kat,count)
	}

	frame  .prf.$kat -relief sunken
	button .prf.$kat.aktiv  -height 1 -width 8 \
		-command "PrfAuswahlKatBut $kat"
	label  .prf.$kat.title  -text $frage($kat,title)
	label  .prf.$kat.gesamt -text $tc -width 10
	entry  .prf.$kat.frage  -width 10 -textvariable pcount($kat)

	if {$pcount($kat) == ""} {
	    set pcount($kat) 0
	}
	if {$pcount($kat) == 0} {
	    set paktiv($kat) 0
	    set pcount($kat) $PDefAnz
	}

	if {$paktiv($kat) == 1} {
	    .prf.$kat.aktiv configure -relief sunken -text ja
	} else {
	    .prf.$kat.aktiv configure -text nein -relief raised
	    .prf.$kat.frage configure -state disabled -foreground \
		    [lindex [.prf.$kat.frage configure -background] 4]
	}

	pack .prf.$kat.aktiv -side left -padx 4
	pack .prf.$kat.title -side left -fill x -expand true -padx 2
	pack .prf.$kat.gesamt .prf.$kat.frage -side left -padx 2
	pack .prf.$kat -side top -fill x
    }

    frame .prf.bot
    button .prf.bot.b1 -text "Prfung Starten" -command "PrfungStarten"
    button .prf.bot.b2 -text "Schlieen" -command "destroy .prf"
    pack .prf.bot.b1 .prf.bot.b2 -side left -fill x -expand true
    pack .prf.bot -fill x

    focus .prf.bot.b1
    bind .prf <Key-Return> "PrfungStarten"
}

#
# ----------------------------------------------------------------------
# Menfunktionen Misc
# ----------------------------------------------------------------------
#

proc About {} {
    global AboutFinish img

    if {[catch {toplevel .about}]} {
	return
    }

    wm title .about "ber PPL-Check"
    set AboutFinish 0

    if {![catch {image create photo -file [file join $img wfpxsm.gif]} pic]} {
	frame .about.f2 -bg "#ffffff"
	label .about.f2.frank -relief flat -bd 0 -image $pic
	pack .about.f2.frank -expand true
	pack .about.f2 -side left -padx 3 -pady 3 -fill both -expand true
    }

    frame .about.f1
    label .about.f1.text1 -text "PPL-Check" \
            -font -Adobe-Helvetica-Bold-R-Normal--*-180-*-*-*-*-*-*
    label .about.f1.text2 -text "Ein Programm von Frank Pilhofer"
    label .about.f1.text3 -text "fp@fpx.de\n\
            http://www.fpx.de/"
    label .about.f1.text4 -text "Fragenkatalog des Bundesministeriums\n\
	    fr Verkehr, Stand Oktober 1999"
    pack .about.f1.text1 .about.f1.text2 .about.f1.text3 .about.f1.text4 \
	    -fill both -padx 10 -pady 5 -side top

    button .about.but -text "Ok" -command {set AboutFinish 1}
    pack .about.but -fill both -padx 10 -pady 3 -side bottom
    pack .about.f1 -fill both -side top
    bind .about <Key-Return> "incr AboutFinish"

    set oldFocus [focus]
    tkwait visibility .about
    grab set .about
    focus .about.but
    vwait AboutFinish
    catch {
	set pic [lindex [.about.f2.frank configure -image] 4]
	.about.f2.frank configure -image ""
	image delete $pic
    }
    destroy .about
    focus $oldFocus
}

proc Allgemeines {} {
    global base tcl_platform

    set file "allgemeines.txt"

    if {![file exists [file join $base $file]]} {
	tk_dialog .dialog {Oops} "Die Datei \"$file\" kann nicht\
		gefunden werden." warning 0 OK
	return
    }

    DisplayFile [file join $base $file] "Allgemeines"
}


proc Hilfe {} {
    global base

    if {![file exists [file join $base ppl.txt]]} {
	tk_dialog .dialog {Oops} "Die Hilfedatei \"ppl.txt\" kann nicht\
		gefunden werden." warning 0 OK
	return
    }

    DisplayFile [file join $base ppl.txt] "Hilfe"
}

proc Lizenz {} {
    global base

    if {![file exists [file join $base lizenz.txt]]} {
	tk_dialog .dialog {Oops} "Die Hilfedatei \"lizenz.txt\" kann nicht\
		gefunden werden." warning 0 OK
	return
    }

    DisplayFile [file join $base lizenz.txt] "Lizenz"
}

proc Versionen {} {
    global frage pplrev loadqrev tcl_patchLevel tk_patchLevel

    if {[catch {toplevel .rev}]} {
	return
    }

    wm title .rev "Versionsinformation"

    frame .rev.ppl
    label .rev.ppl.txt -text "ppl" -width 12
    label .rev.ppl.rev -text "[lindex $pplrev 2] [lindex $pplrev 3]"
    pack .rev.ppl.txt -side left
    pack .rev.ppl.rev -side right -fill x -expand true
    pack .rev.ppl -side top -fill x

    frame .rev.loadq
    label .rev.loadq.txt -text "loadq" -width 12
    label .rev.loadq.rev -text "[lindex $loadqrev 2] [lindex $loadqrev 3]"
    pack .rev.loadq.txt -side left
    pack .rev.loadq.rev -side right -fill x -expand true
    pack .rev.loadq -side top -fill x

    frame .rev.tcl
    label .rev.tcl.txt -text "tcl" -width 12
    label .rev.tcl.rev -text "$tcl_patchLevel"
    pack .rev.tcl.txt -side left
    pack .rev.tcl.rev -side right -fill x -expand true
    pack .rev.tcl -side top -fill x

    frame .rev.tk
    label .rev.tk.txt -text "tk" -width 12
    label .rev.tk.rev -text "$tk_patchLevel"
    pack .rev.tk.txt -side left
    pack .rev.tk.rev -side right -fill x -expand true
    pack .rev.tk -side top -fill x

    foreach kat [lsort [array names frage *rev]] {
	set prefix [lindex [split $kat ,] 0]
	frame .rev.$prefix
	label .rev.$prefix.txt -text "$prefix" -width 12
	label .rev.$prefix.rev -text "[lindex $frage($kat) 2] [lindex $frage($kat) 3]"
	pack .rev.$prefix.txt -side left
	pack .rev.$prefix.rev -side right -fill x -expand true
	pack .rev.$prefix -side top -fill x
    }

    frame .rev.bot -relief raised
    button .rev.bot.bb -text "Schlieen" -command "destroy .rev"
    pack .rev.bot.bb -side left -fill x -expand true
    pack .rev.bot -side bottom -fill x

    bind .rev <Key-Return> "destroy .rev"
    focus .rev.bot.bb
}

proc Beenden {} {
    global images main status icon

    WirklichRcksetzen

    if {$status != 0} {
	return
    }

    foreach image [array names images] {
	image delete $images($image)
    }

    catch {
	wm iconwindow $main {}
	image delete $icon
	destroy .icon
    }
    destroy $main
    destroy .
    exit 0
}

#
# ----------------------------------------------------------------------
# Main
# ----------------------------------------------------------------------
#

if {[catch {set IsSetUp}]} {
    wm withdraw .
    toplevel .main
    set main .main

    wm protocol .main WM_DELETE_WINDOW {destroy .}

    SetUpMain $main
    SetUpTraces
    set IsSetUp 1

    wm title $main "PPL-Check"

    if {$tcl_platform(platform) != "windows"} {
	catch {
	    set icon [image create photo -file [file join $img icon_48.gif]]
	    toplevel .icon
	    label .icon.text -image $icon
	    pack .icon.text
	    if {[catch {wm iconwindow $main .icon}]} {
		image delete $icon
		destroy .icon
	    }
	}
    }

    $main.status.left configure -text "Okay"
}
